git@vger.kernel.org list mirror (unofficial, one of many)
 help / color / mirror / Atom feed
* [PATCH v1] hook: add sample template for push-to-checkout
@ 2020-10-15 18:47 Adam Spiers
  2020-10-15 20:43 ` Junio C Hamano
  0 siblings, 1 reply; 3+ messages in thread
From: Adam Spiers @ 2020-10-15 18:47 UTC (permalink / raw)
  To: git list

The template is a more-or-less exact translation to shell of the C
code for the default behaviour for git's push-to-checkout hook defined
in the push_to_deploy() function in builtin/receive-pack.c, to serve
as a convenient starting point for modification.

It also contains relevant text extracted from the git-config(1) and
githooks(5) man pages.

Signed-off-by: Adam Spiers <git@adamspiers.org>
---
 templates/hooks--push-to-checkout.sample | 74 ++++++++++++++++++++++++
 1 file changed, 74 insertions(+)
 create mode 100755 templates/hooks--push-to-checkout.sample

diff --git a/templates/hooks--push-to-checkout.sample b/templates/hooks--push-to-checkout.sample
new file mode 100755
index 0000000000..2c6e06f8f1
--- /dev/null
+++ b/templates/hooks--push-to-checkout.sample
@@ -0,0 +1,74 @@
+#!/bin/bash
+
+# An example hook script to update a checked-out tree on a git push.
+#
+# This hook is invoked by git-receive-pack(1) when it reacts to git
+# push and updates reference(s) in its repository, and when the push
+# tries to update the branch that is currently checked out and the
+# receive.denyCurrentBranch configuration variable is set to
+# updateInstead.
+#
+# By default, such a push is refused if the working tree and the index
+# of the remote repository has any difference from the currently
+# checked out commit; when both the working tree and the index match
+# the current commit, they are updated to match the newly pushed tip
+# of the branch. This hook is to be used to override the default
+# behaviour; however the code below reimplements the default behaviour
+# as a starting point for convenient modification.
+#
+# The hook receives the commit with which the tip of the current
+# branch is going to be updated:
+commit="$1"
+#echo "push-to-checkout $commit"
+
+# It can exit with a non-zero status to refuse the push (when it does
+# so, it must not modify the index or the working tree).
+die () {
+    echo >&2 "$*"
+    exit 1
+}
+
+# Or it can make any necessary changes to the working tree and to the
+# index to bring them to the desired state when the tip of the current
+# branch is updated to the new commit, and exit with a zero status.
+#
+# For example, the hook can simply run git read-tree -u -m HEAD "$1"
+# in order to emulate git fetch that is run in the reverse direction
+# with git push, as the two-tree form of git read-tree -u -m is
+# essentially the same as git switch or git checkout that switches
+# branches while keeping the local changes in the working tree that do
+# not interfere with the difference between the branches.
+
+# The below is a more-or-less exact translation to shell of the C code
+# for the default behaviour for git's push-to-checkout hook defined in
+# the push_to_deploy() function in builtin/receive-pack.c.
+#
+# Note that the hook will be executed from the repository directory,
+# not from the working tree, so if you want to perform operations on
+# the working tree, you will have to adapt your code accordingly, e.g.
+# by adding "cd .." or using relative paths.
+
+if ! git update-index -q --ignore-submodules --refresh; then
+    die "Up-to-date check failed"
+fi
+
+if ! git diff-files --quiet --ignore-submodules --; then
+    die "Working directory has unstaged changes"
+fi
+
+# This is a rough translation of:
+#
+#    head_has_history() ? "HEAD" : EMPTY_TREE_SHA1_HEX
+if git cat-file -t HEAD >&/dev/null; then
+    head=HEAD
+else
+    head=4b825dc642cb6eb9a060e54bf8d69288fbee4904
+fi
+
+if ! git diff-index --quiet --cached --ignore-submodules $head --; then
+    die "Working directory has staged changes"
+fi
+
+if ! git read-tree -u -m $commit; then
+    die "Could not update working tree to new HEAD"
+fi
-- 
2.26.1


^ permalink raw reply	[flat|nested] 3+ messages in thread

* Re: [PATCH v1] hook: add sample template for push-to-checkout
  2020-10-15 18:47 [PATCH v1] hook: add sample template for push-to-checkout Adam Spiers
@ 2020-10-15 20:43 ` Junio C Hamano
  2020-10-15 22:54   ` [PATCH v2] " Adam Spiers
  0 siblings, 1 reply; 3+ messages in thread
From: Junio C Hamano @ 2020-10-15 20:43 UTC (permalink / raw)
  To: Adam Spiers; +Cc: git list

Adam Spiers <git@adamspiers.org> writes:

> The template is a more-or-less exact translation to shell of the C
> code for the default behaviour for git's push-to-checkout hook defined
> in the push_to_deploy() function in builtin/receive-pack.c, to serve
> as a convenient starting point for modification.
>
> It also contains relevant text extracted from the git-config(1) and
> githooks(5) man pages.
>
> Signed-off-by: Adam Spiers <git@adamspiers.org>
> ---
>  templates/hooks--push-to-checkout.sample | 74 ++++++++++++++++++++++++
>  1 file changed, 74 insertions(+)
>  create mode 100755 templates/hooks--push-to-checkout.sample
>
> diff --git a/templates/hooks--push-to-checkout.sample b/templates/hooks--push-to-checkout.sample
> new file mode 100755
> index 0000000000..2c6e06f8f1
> --- /dev/null
> +++ b/templates/hooks--push-to-checkout.sample
> @@ -0,0 +1,74 @@
> +#!/bin/bash

If we want to make this part of the sample hooks shown to everybody,
we should stick to /bin/sh if we could.  Do you have to rely on any
bash-ism that are not found in other shells to write this script, or
is this just shows your inertia that you always work with bash?

> +# The hook receives the commit with which the tip of the current
> +# branch is going to be updated:
> +commit="$1"

Strictly speaking, a parameter on the right hand side of an
assignment does not have to get dquoted to protect it from getting
munged at $IFS, so this can be

	commit=$1

but it gives us an important clue.  If $1 is worth protecting from
getting munged at $IFS, then we should assume later use of $commit
must be careful the same way.

> +#echo "push-to-checkout $commit"

Leftover debugging statement to be removed (instead of commented
out).

> +# It can exit with a non-zero status to refuse the push (when it does
> +# so, it must not modify the index or the working tree).
> +die () {
> +    echo >&2 "$*"
> +    exit 1
> +}

Style (Documentation/CodingGudielines).  One level of indent is a
single tab byte in our codebase.


> +if ! git update-index -q --ignore-submodules --refresh; then

Style (Documentation/CodingGudielines).

> +    die "Up-to-date check failed"

This is "failed to refresh" (in other words, not being up-to-date is
OK and that is not what we are checking), but the patch is meant as
a faithful translation of the original, so it is OK here.

> +fi
> +
> +if ! git diff-files --quiet --ignore-submodules --; then
> +    die "Working directory has unstaged changes"
> +fi
> +
> +# This is a rough translation of:
> +#
> +#    head_has_history() ? "HEAD" : EMPTY_TREE_SHA1_HEX
> +if git cat-file -t HEAD >&/dev/null; then

Is ">&/dev/null" portable?  I'd rather see it written like

	git cat-file -t HEAD >/dev/null 2>&1

to be portable.

cf. https://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_07 

But there is a better way to spell it (see below).

> +    head=HEAD
> +else
> +    head=4b825dc642cb6eb9a060e54bf8d69288fbee4904

This hardcodes the object name from SHA-1 world, and will break
after the user migrates to SHA-256.

> +fi

Here is probably a better version.

	if git cat-file -e HEAD
	then
		head=HEAD
	else
		head=$(git hash-object -t tree --stdin </dev/null)
	fi




> +
> +if ! git diff-index --quiet --cached --ignore-submodules $head --; then
> +    die "Working directory has staged changes"
> +fi
> +
> +if ! git read-tree -u -m $commit; then

You forgot "" around $commit here.  Here, an $IFS byte in $commit will
get the command line munged.  I.e.

	if ! git read-tree -u -m "$commit"
	then
		...

> +    die "Could not update working tree to new HEAD"
> +fi

Thanks.

^ permalink raw reply	[flat|nested] 3+ messages in thread

* Re: [PATCH v2] hook: add sample template for push-to-checkout
  2020-10-15 20:43 ` Junio C Hamano
@ 2020-10-15 22:54   ` Adam Spiers
  0 siblings, 0 replies; 3+ messages in thread
From: Adam Spiers @ 2020-10-15 22:54 UTC (permalink / raw)
  To: Junio C Hamano; +Cc: git list

On Thu, Oct 15, 2020 at 01:43:28PM -0700, Junio C Hamano wrote: 
>Adam Spiers <git@adamspiers.org> writes: 
>
>>The template is a more-or-less exact translation to shell of the C 
>>code for the default behaviour for git's push-to-checkout hook defined 
>>in the push_to_deploy() function in builtin/receive-pack.c, to serve 
>>as a convenient starting point for modification. 
>>
>>It also contains relevant text extracted from the git-config(1) and 
>>githooks(5) man pages. 
>>
>>Signed-off-by: Adam Spiers <git@adamspiers.org> 
>>---
>>  templates/hooks--push-to-checkout.sample | 74 ++++++++++++++++++++++++ 
>>  1 file changed, 74 insertions(+) 
>>  create mode 100755 templates/hooks--push-to-checkout.sample 
>>
>>diff --git a/templates/hooks--push-to-checkout.sample b/templates/hooks--push-to-checkout.sample 
>>new file mode 100755 
>>index 0000000000..2c6e06f8f1 
>>--- /dev/null 
>>+++ b/templates/hooks--push-to-checkout.sample 
>>@@ -0,0 +1,74 @@ 
>>+#!/bin/bash 
>
>If we want to make this part of the sample hooks shown to everybody, 
>we should stick to /bin/sh if we could.  Do you have to rely on any 
>bash-ism that are not found in other shells to write this script, or 
>is this just shows your inertia that you always work with bash? 

I usually work with bash and zsh, and just forgot to convert it in 
this case.

>>+# The hook receives the commit with which the tip of the current 
>>+# branch is going to be updated: 
>>+commit="$1" 
>
>Strictly speaking, a parameter on the right hand side of an 
>assignment does not have to get dquoted to protect it from getting 
>munged at $IFS, so this can be 
>
>	commit=$1

Ah, interesting thanks - not sure why it's taken me 25 years to 
discover that. 

-- >8 --
Subject: [PATCH v2] hook: add sample template for push-to-checkout

The template is a more-or-less exact translation to shell of the C
code for the default behaviour for git's push-to-checkout hook defined
in the push_to_deploy() function in builtin/receive-pack.c, to serve
as a convenient starting point for modification.

It also contains relevant text extracted from the git-config(1) and
githooks(5) man pages.

Signed-off-by: Adam Spiers <git@adamspiers.org>
---
  templates/hooks--push-to-checkout.sample | 78 ++++++++++++++++++++++++
  1 file changed, 78 insertions(+)
  create mode 100755 templates/hooks--push-to-checkout.sample

diff --git a/templates/hooks--push-to-checkout.sample b/templates/hooks--push-to-checkout.sample
new file mode 100755
index 0000000000..af5a0c0018
--- /dev/null
+++ b/templates/hooks--push-to-checkout.sample
@@ -0,0 +1,78 @@
+#!/bin/sh
+
+# An example hook script to update a checked-out tree on a git push.
+#
+# This hook is invoked by git-receive-pack(1) when it reacts to git
+# push and updates reference(s) in its repository, and when the push
+# tries to update the branch that is currently checked out and the
+# receive.denyCurrentBranch configuration variable is set to
+# updateInstead.
+#
+# By default, such a push is refused if the working tree and the index
+# of the remote repository has any difference from the currently
+# checked out commit; when both the working tree and the index match
+# the current commit, they are updated to match the newly pushed tip
+# of the branch. This hook is to be used to override the default
+# behaviour; however the code below reimplements the default behaviour
+# as a starting point for convenient modification.
+#
+# The hook receives the commit with which the tip of the current
+# branch is going to be updated:
+commit=$1
+
+# It can exit with a non-zero status to refuse the push (when it does
+# so, it must not modify the index or the working tree).
+die () {
+	echo >&2 "$*"
+	exit 1
+}
+
+# Or it can make any necessary changes to the working tree and to the
+# index to bring them to the desired state when the tip of the current
+# branch is updated to the new commit, and exit with a zero status.
+#
+# For example, the hook can simply run git read-tree -u -m HEAD "$1"
+# in order to emulate git fetch that is run in the reverse direction
+# with git push, as the two-tree form of git read-tree -u -m is
+# essentially the same as git switch or git checkout that switches
+# branches while keeping the local changes in the working tree that do
+# not interfere with the difference between the branches.
+
+# The below is a more-or-less exact translation to shell of the C code
+# for the default behaviour for git's push-to-checkout hook defined in
+# the push_to_deploy() function in builtin/receive-pack.c.
+#
+# Note that the hook will be executed from the repository directory,
+# not from the working tree, so if you want to perform operations on
+# the working tree, you will have to adapt your code accordingly, e.g.
+# by adding "cd .." or using relative paths.
+
+if ! git update-index -q --ignore-submodules --refresh
+then
+	die "Up-to-date check failed"
+fi
+
+if ! git diff-files --quiet --ignore-submodules --
+then
+	die "Working directory has unstaged changes"
+fi
+
+# This is a rough translation of:
+#
+#   head_has_history() ? "HEAD" : EMPTY_TREE_SHA1_HEX
+if git cat-file -e HEAD 2>/dev/null
+then
+	head=HEAD
+else
+	head=$(git hash-object -t tree --stdin </dev/null)
+fi
+
+if ! git diff-index --quiet --cached --ignore-submodules $head --
+then
+	die "Working directory has staged changes"
+fi
+
+if ! git read-tree -u -m "$commit"
+then
+	die "Could not update working tree to new HEAD"
+fi
-- 
2.28.0


^ permalink raw reply	[flat|nested] 3+ messages in thread

end of thread, other threads:[~2020-10-15 22:54 UTC | newest]

Thread overview: 3+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-10-15 18:47 [PATCH v1] hook: add sample template for push-to-checkout Adam Spiers
2020-10-15 20:43 ` Junio C Hamano
2020-10-15 22:54   ` [PATCH v2] " Adam Spiers

git@vger.kernel.org list mirror (unofficial, one of many)

This inbox may be cloned and mirrored by anyone:

	git clone --mirror https://public-inbox.org/git
	git clone --mirror http://ou63pmih66umazou.onion/git
	git clone --mirror http://czquwvybam4bgbro.onion/git
	git clone --mirror http://hjrcffqmbrq6wope.onion/git

	# If you have public-inbox 1.1+ installed, you may
	# initialize and index your mirror using the following commands:
	public-inbox-init -V1 git git/ https://public-inbox.org/git \
		git@vger.kernel.org
	public-inbox-index git

Example config snippet for mirrors.
Newsgroups are available over NNTP:
	nntp://news.public-inbox.org/inbox.comp.version-control.git
	nntp://ou63pmih66umazou.onion/inbox.comp.version-control.git
	nntp://czquwvybam4bgbro.onion/inbox.comp.version-control.git
	nntp://hjrcffqmbrq6wope.onion/inbox.comp.version-control.git
	nntp://news.gmane.io/gmane.comp.version-control.git
 note: .onion URLs require Tor: https://www.torproject.org/

code repositories for the project(s) associated with this inbox:

	https://80x24.org/mirrors/git.git

AGPL code for this site: git clone https://public-inbox.org/public-inbox.git